unit apconvert;

interface
uses
  Windows;
  
type
//1.1 SDK interface definitions.
//==========================================================================================
    _FapOpen = function(pFileName:PChar; pOwnerPw:PChar; pUserPw:PChar):Longint; stdcall;
    _FapClose = function(nHandle:Longint):Longint; stdcall;
    _FapConvert = function(nHandle:Longint):Longint; stdcall;
    _FapConvertPage = function(nHandle:Longint; nPageNo:Longint):Longint; stdcall;
    _FapConvertPageToStream = function(nHandle:Longint;
                                       nPageNo:Longint;
                                       var pMemStream:PByte;
                                       var nSize:Longint):Longint; stdcall;
    _FapSetProperty = function(nHandle:Longint; //Conversion object's handle.
                               nIndex:Longint;  //Property tag,refer to the following property definitions.
                               pValue:PChar;    //A String value of the property,(or)
                               nValue:Longint;  //An integer value of the property.
                               nOther:Longint):Longint; stdcall; //Only valid for progress call-back.
    _FapGetProperty = function(nHandle:Longint; //Conversion object's handle.
                               nIndex:Longint;  //Property tag,refer to the following property definitions.
                               pValue:PChar;    //A String value of the property,(or)
                               var nValue:Longint):Longint; stdcall;  //An integer value of the property.
//==========================================================================================


const
//1.2 Definitions of converter's properties
//==========================================================================================
    //read/write properties
    AP_PROP_OUTDIR       = 1;  //Destination directory.
    AP_PROP_PREFIX       = 2;  //The prefix of the name of result image file.
    AP_PROP_PAGEZOOM     = 3;  //Zoom scale of the source pdf page.
    AP_PROP_BGCOLOR      = 4;  //Image background color.
    AP_PROP_BITCOUNT     = 6;  //Color bits per pixel.
    AP_PROP_XDPI         = 7;  //Horizontal resolution.
    AP_PROP_YDPI         = 8;  //Vertical resolution.
    AP_PROP_QUALITY      = 9;  //JPEG compression quality.
    AP_PROP_COMPRESSION  = 10; //TIFF compression mode.
    AP_PROP_MULTIPAGES   = 11; //Multipages TIFF file.
    AP_PROP_GRAYSCALE    = 12; //Grayscale image.
    AP_PROP_XDIMENSIONS  = 13; //The width of the result image in pixel
    AP_PROP_YDIMENSIONS  = 14; //The height of the result image in pixel
    
    //read only properties
    AP_PROP_PAGECOUNT  = 20; //The total pages of source pdf file.
    AP_PROP_PAGEHEIGHT = 21; //Height of the current page of source pdf file.
    AP_PROP_PAGEWIDTH  = 22; //Width of the current page of source pdf file.

    //write only properties
    AP_PROP_PROGRESSFUNC = 40; //Address of the progress call-back function.
//==========================================================================================

//1.3 TIFF tag's definitions.
//==========================================================================================
    AP_TIFF_COMPRESSION_NONE     = 0;  //No compression.
    AP_TIFF_COMPRESSION_LZW      = 1;  //1,4,8,24bits(default 4,8,24bits)
    AP_TIFF_COMPRESSION_JPEG     = 2;  //Grayscale 8bits,24bits
    AP_TIFF_COMPRESSION_PACKBITS = 3;  //4,8,24bits
    AP_TIFF_COMPRESSION_CCITTG4  = 4;  //1bit(default 1bit)
    AP_TIFF_COMPRESSION_CCITTG3  = 5;  //1bit
    AP_TIFF_COMPRESSION_RLE      = 6;  //1bit
//==========================================================================================

//1.4 Return code definitions.
//==========================================================================================
    RTN_OK = 1;           //Successful operation.
    ERR_UNKNOWN = -99;    //Unknown system error.
    
    ERR_OVER_MAXTHREADS    = -1;  //Over the limit amount of threads
    ERR_FILE_UNEXIST       = -2;  //Source PDF file unexist.
    ERR_FILE_DAMAGED       = -3;  //Source PDF file is damaged.
    ERR_FILE_RESTRICTED    = -4;  //Source PDF file is restricted.
    
    ERR_INVALID_PAGE    = -5;   //The PDF page is invalid.
    ERR_CONVERT_FAILURE = -8;   //Conversion failure.
    ERR_INVALID_STREAM  = -9;   //Invalid memory stream address.
    ERR_INVALID_HANDLE  = -10;  //Invalid converter's handle.
//==========================================================================================

implementation

end.
